//FirstView Component Constructor

var length1 = 0;
var imageBuffer = '';

function FirstView() {
	//create object instance, a parasitic subclass of Observable
	var self = Ti.UI.createView();
	
	//label using localization-ready strings from <app dir>/i18n/en/strings.xml
	var label = Ti.UI.createLabel({
		color:'#000000',
		text:String.format(L('welcome'),'Titanium'),
		height:'100',
		width:'100',
		top : 500,
		left : 0
	});
	self.add(label);
	
	iv = Ti.UI.createImageView({
	    width : '200',
	    height : '200',
	    left : 0,
	    top : 0,
	    borderColor : '#ff0000',
	    backgroundColor : '#00ff00'
	});
	self.add(iv);
	
	//Add behavior for UI
	label.addEventListener('click', function(e) {
		alert(e.source.text);
	});
	
	sdPath = 'file:///sdcard/';
	folder = Ti.Filesystem.getFile(sdPath, 'ADownloads');
    if(!folder.exists()) {
        folder.createDirectory();
    }
    newPath = 'file:///sdcard/ADownloads/' + 'sample.jpg';
    tmpFile = Ti.Filesystem.getFile(newPath);
	
	controlSocket = Titanium.Network.Socket.createTCP({
	    host: 'www.sydneyobservatory.com.au', port: 80,timeout: 5000,
	    connected : function(e) {
	        Ti.API.info("Connected " + e.socket.port);
	        Ti.API.info("The path is: " + tmpFile.nativePath);
	        
	        Ti.Stream.pump(controlSocket, readCallback, 1024, true);
            Ti.Stream.write(controlSocket, Ti.createBuffer({
                value : 'GET /wp-content/uploads/2011/02/409950main_image_1538_946-710_Moon_NASA.jpg Http1.1\r\n' + 'Host: www.sydneyobservatory.com.au\r\nAccept-Charset: utf-8\r\nAccept: image/jpeg\r\n\r\n'
            }), writeCallback);
	    },
	    accepted : function(e) {
            Ti.API.info("Accepted " + e);
        },
        error : function(e) {
            Ti.API.info("Error " + e.errorCode);
        },
	});
    
    controlSocket.connect();

	
	return self;
}



function readCallback(e) {
    //Ti.API.info('Successfully READ FROM socket. ' + e.buffer);
    // Ti.API.info('Successfully READ FROM socket string. ' + e.buffer.toString());
    
    if(e.bytesProcessed == -1) {
        controlSocket.close();
        return;
    }
    
    var HTTPHeaderDelimiter = "\r\n\r\n";
    //Ti.API.info("The delimerter position is: " + e.buffer.toString().indexOf("HTTP/1.1 200 OK"));
    //Ti.API.info("The delimerter position is: " + e.buffer.toString().indexOf(HTTPHeaderDelimiter));
    var imageBuffer = e.buffer.toString();
    if(-1 != e.buffer.toString().indexOf("HTTP/1.1 200 OK")) {
        Ti.API.info("newImageBuffer has been written");
        var newImageBuffer = imageBuffer.substring(imageBuffer.indexOf(HTTPHeaderDelimiter), imageBuffer.length);
        Ti.API.info(newImageBuffer);
        tmpFile.write(newImageBuffer, true);
        length1 = length1 + newImageBuffer.length;
    } else {
        tmpFile.write(e.buffer, true);
        length1 = length1 + e.buffer.length;
    }
    
    //tmpFile.write(data);
    
    //imageBuffer += e.buffer;
    //Ti.API.info('Successfully READ FROM socket. ' + e.buffer.length);
    
    Ti.API.info('Successfully total read. ' + length1);
}

function writeCallback(e) {
    Ti.API.info('Successfully wrote to socket.');
}
 


module.exports = FirstView;
